include<tile.scad>;
include<LX15D.scad>;

tile_a = 24;
t = 3;
tile_t = 5;
middle_t = 10;
coxa_z_space = 10;

module body_collision_a(positions) {
    hull() for (pos = positions) {
        translate(pos)
            cube([ LX15D_dim[1], LX15D_dim[1], LX15D_horn_w ], center = true);
    }
}

module body(positions) {
    $fn = 32;

    for (pos = positions)
        translate(pos) rotate([ 0, 0, pos[1] > 0 ? -90 : 90 ]) {
            LX15D();
            LX15D_U();
        }

    rotate([ 90, 0, 0 ]) for (i = [-1.5:1.5]) translate([ i * tile_a, 0, 0 ]) {
        tile(T24, middle_t, center = true);
    }
}

body(positions = [
    [ 36.0, -45.0, 0.0 ], [ -36.0, -45.0, 0.0 ], [ 36.0, 45.0, 0.0 ],
    [ -36.0, 45.0, 0.0 ]
]);
